'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var retryableFetch = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(url, _ref2) {
    var maxRetries = _ref2.maxRetries,
        maxRetryDelay = _ref2.maxRetryDelay,
        options = (0, _objectWithoutProperties3.default)(_ref2, ['maxRetries', 'maxRetryDelay']);
    var result, currentRetry, jitterMs, wait;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return fetch(url, options);

          case 2:
            result = _context.sent;

            if (!(result.ok || !RETRY_STATUS.includes(result.status))) {
              _context.next = 5;
              break;
            }

            return _context.abrupt('return', result);

          case 5:
            currentRetry = 0;

          case 6:
            if (!(currentRetry < maxRetries)) {
              _context.next = 19;
              break;
            }

            jitterMs = Math.round(Math.random() * 1000);
            wait = Math.min(maxRetryDelay, Math.pow(2, currentRetry) * 1000) + jitterMs;
            _context.next = 11;
            return delay(wait);

          case 11:
            _context.next = 13;
            return fetch(url, options);

          case 13:
            result = _context.sent;

            if (!(result.ok || !RETRY_STATUS.includes(result.status))) {
              _context.next = 16;
              break;
            }

            return _context.abrupt('break', 19);

          case 16:
            currentRetry++;
            _context.next = 6;
            break;

          case 19:
            return _context.abrupt('return', result);

          case 20:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function retryableFetch(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

exports.apiClient = apiClient;

require('isomorphic-fetch');

var _package = require('../package.json');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var delay = function delay(t) {
  return new _promise2.default(function (resolve) {
    return setTimeout(resolve, t);
  });
};

var RETRY_STATUS = [429, 500, 502, 503, 504];

var ApiClient = function () {
  function ApiClient(_ref3) {
    var apikey = _ref3.apikey,
        _ref3$apihost = _ref3.apihost,
        apihost = _ref3$apihost === undefined ? 'https://api.logrocket.com' : _ref3$apihost;
    (0, _classCallCheck3.default)(this, ApiClient);

    this.apikey = apikey;
    this.apihost = apihost;
  }

  (0, _createClass3.default)(ApiClient, [{
    key: '_makeRequest',
    value: function () {
      var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(_ref5) {
        var url = _ref5.url,
            data = _ref5.data;

        var _apikey$split, _apikey$split2, orgSlug, appSlug;

        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _apikey$split = this.apikey.split(':'), _apikey$split2 = (0, _slicedToArray3.default)(_apikey$split, 2), orgSlug = _apikey$split2[0], appSlug = _apikey$split2[1];
                return _context2.abrupt('return', fetch(this.apihost + '/v1/orgs/' + orgSlug + '/apps/' + appSlug + '/' + url + '/', {
                  method: 'POST',
                  headers: this.headers,
                  body: (0, _stringify2.default)(data),
                  duplex: 'half'
                }));

              case 2:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function _makeRequest(_x3) {
        return _ref4.apply(this, arguments);
      }

      return _makeRequest;
    }()
  }, {
    key: 'checkStatus',
    value: function () {
      var _ref6 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3() {
        var res, data;
        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return fetch(this.apihost + '/cli/status/', {
                  headers: this.headers
                });

              case 2:
                res = _context3.sent;

                if (!(res.status === 204)) {
                  _context3.next = 5;
                  break;
                }

                return _context3.abrupt('return');

              case 5:
                data = void 0;
                _context3.prev = 6;
                _context3.next = 9;
                return res.json();

              case 9:
                data = _context3.sent;
                _context3.next = 16;
                break;

              case 12:
                _context3.prev = 12;
                _context3.t0 = _context3['catch'](6);

                console.error('Could not verify CLI status. Check your network connection and reinstall the LogRocket CLI if the problem persists.');
                process.exit(1);

              case 16:

                if (!res.ok) {
                  console.error(data.message);
                  process.exit(1);
                } else {
                  console.info(data.message);
                }

              case 17:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this, [[6, 12]]);
      }));

      function checkStatus() {
        return _ref6.apply(this, arguments);
      }

      return checkStatus;
    }()
  }, {
    key: 'createRelease',
    value: function () {
      var _ref7 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4(_ref8) {
        var version = _ref8.version;
        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                return _context4.abrupt('return', this._makeRequest({
                  url: 'releases',
                  data: { version: version }
                }));

              case 1:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function createRelease(_x4) {
        return _ref7.apply(this, arguments);
      }

      return createRelease;
    }()
  }, {
    key: 'uploadFile',
    value: function () {
      var _ref9 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5(_ref10) {
        var contents = _ref10.contents,
            data = _ref10.data,
            maxRetries = _ref10.maxRetries,
            maxRetryDelay = _ref10.maxRetryDelay,
            url = _ref10.url;
        var res, fileData, gcloudUrl, result;
        return _regenerator2.default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                _context5.next = 2;
                return this._makeRequest({ url: url, data: data });

              case 2:
                res = _context5.sent;

                if (res.ok) {
                  _context5.next = 5;
                  break;
                }

                return _context5.abrupt('return', res);

              case 5:
                _context5.next = 7;
                return res.json();

              case 7:
                fileData = _context5.sent;
                gcloudUrl = fileData.signed_url;

                if (gcloudUrl) {
                  _context5.next = 11;
                  break;
                }

                throw new Error('Could not get upload url for: ' + data.filepath);

              case 11:
                _context5.next = 13;
                return retryableFetch(gcloudUrl, {
                  maxRetries: maxRetries,
                  maxRetryDelay: maxRetryDelay,
                  method: 'PUT',
                  body: contents,
                  duplex: 'half'
                });

              case 13:
                result = _context5.sent;

                if (!this._gcsBucket) {
                  _context5.next = 17;
                  break;
                }

                _context5.next = 17;
                return fetch(this.apihost + '/gcloud/', {
                  method: 'PUT',
                  headers: {
                    'Content-Type': 'application/json',
                    'X-Goog-Channel-Token': this._gcsToken
                  },
                  body: (0, _stringify2.default)({
                    name: fileData.name,
                    bucket: this._gcsBucket
                  }),
                  duplex: 'half'
                });

              case 17:
                return _context5.abrupt('return', result);

              case 18:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function uploadFile(_x5) {
        return _ref9.apply(this, arguments);
      }

      return uploadFile;
    }()
  }, {
    key: 'setGCSData',
    value: function setGCSData(_ref11) {
      var gcsToken = _ref11.gcsToken,
          gcsBucket = _ref11.gcsBucket;

      this._gcsToken = gcsToken;
      this._gcsBucket = gcsBucket;
    }
  }, {
    key: 'headers',
    get: function get() {
      return {
        Authorization: 'Token ' + this.apikey,
        Accept: 'application/json',
        'Content-Type': 'application/json',
        'X-LogRocket-Cli-Version': _package.version
      };
    }
  }]);
  return ApiClient;
}();

function apiClient(config) {
  return new ApiClient(config);
}