'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.handler = exports.builder = exports.describe = exports.command = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _PLATFORM_UPLOAD;

var _uploadMacho = require('../uploadMacho.js');

var _uploadProguard = require('../uploadProguard.js');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var PLATFORMS = {
  IOS: 'ios',
  ANDROID: 'android'
};

var PLATFORM_UPLOAD = (_PLATFORM_UPLOAD = {}, (0, _defineProperty3.default)(_PLATFORM_UPLOAD, PLATFORMS.IOS, _uploadMacho.uploadMachO), (0, _defineProperty3.default)(_PLATFORM_UPLOAD, PLATFORMS.ANDROID, _uploadProguard.uploadProguard), _PLATFORM_UPLOAD);

var command = exports.command = 'upload-mobile <paths..>';
var describe = exports.describe = 'Upload debug file(s) for a mobile release';

var sampleiOSUploadPath = '/build/MyApp-iphoneos.xcarchive/dSYMs/MyApp.framework.dSYM/Contents/Resources/';

var builder = exports.builder = function builder(args) {
  args.usage('\nUsage: logrocket [-k <apikey>] upload-mobile [-r <release>] [-p <platform>] <paths..>').option('r', {
    alias: 'release',
    type: 'string',
    describe: 'The release version for these files',
    demand: 'You must specify a release, use -r or --release'
  }).demand(1, 'Missing upload path, e.g. logrocket upload-mobile -p ios -r 1.2.3 ' + sampleiOSUploadPath).option('p', {
    alias: 'platform',
    choices: ['ios', 'android'],
    describe: 'The mobile platform of this file (or files)',
    demand: 'You must specify a platform (ios|android), use -p or --platform'
  }).option('gcs-token', { // for testing, pass the webhook token to get an immediate pending=no
    type: 'string',
    describe: false
  }).option('gcs-bucket', { // for testing, pass the webhook bucket to get an immediate pending=no
    type: 'string',
    describe: false
  }).implies({
    'gcs-token': 'gcs-bucket',
    'gcs-bucket': 'gcs-token'
  }).option('max-retries', {
    type: 'number',
    describe: 'Failed upload retry limit (0 disables)',
    default: 0
  }).option('max-retry-delay', {
    type: 'number',
    describe: 'Maximum delay between retries in ms',
    default: 30000
  }).help('help');
};

var handler = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(args) {
    var platform, rest;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            platform = args.platform, rest = (0, _objectWithoutProperties3.default)(args, ['platform']);

            PLATFORM_UPLOAD[platform](rest);

          case 2:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined);
  }));

  return function handler(_x) {
    return _ref.apply(this, arguments);
  };
}();
exports.handler = handler;