'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MissingUUIDError = exports.LoadCommandError = exports.MagicNumberError = exports.BufferRangeError = exports.DataViewError = exports.ERROR_NAMES = exports.WrappedError = undefined;

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

exports.handleFileError = handleFileError;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var WrappedError = exports.WrappedError = function (_Error) {
  (0, _inherits3.default)(WrappedError, _Error);

  function WrappedError(msg, originalError, name) {
    (0, _classCallCheck3.default)(this, WrappedError);

    var _this = (0, _possibleConstructorReturn3.default)(this, (WrappedError.__proto__ || (0, _getPrototypeOf2.default)(WrappedError)).call(this, msg));

    _this.name = name;
    var stack = originalError.stack,
        oeName = originalError.name,
        message = originalError.message;

    var oeStack = stack || '$' + oeName + ': ' + message;
    _this.stack = _this.name + ': ' + _this.message + '\n\nOriginal error: ' + oeStack;
    return _this;
  }

  return WrappedError;
}(Error);

var ERROR_CODES = {
  EACCES: 'EACCES',
  ENOENT: 'ENOENT',
  ETIMEDOUT: 'ETIMEDOUT'
};

var ERROR_NAMES = exports.ERROR_NAMES = {
  AccessError: 'AccessError',
  FileNotFoundError: 'FileNotFoundError',
  TimedOutError: 'TimedOutError',
  OutOfRangeError: 'OutOfRangeError',
  ReadFileError: 'ReadFileError',
  MagicNumberError: 'MagicNumberError',
  DataViewError: 'DataViewError',
  BufferRangeError: 'BufferRangeError',
  LoadCommandError: 'LoadCommandError',
  MissingUUIDError: 'MissingUUIDError'
};

var AccessError = function (_WrappedError) {
  (0, _inherits3.default)(AccessError, _WrappedError);

  function AccessError(msg, originalError) {
    (0, _classCallCheck3.default)(this, AccessError);
    return (0, _possibleConstructorReturn3.default)(this, (AccessError.__proto__ || (0, _getPrototypeOf2.default)(AccessError)).call(this, msg, originalError, ERROR_NAMES.AccessError));
  }

  return AccessError;
}(WrappedError);

var FileNotFoundError = function (_WrappedError2) {
  (0, _inherits3.default)(FileNotFoundError, _WrappedError2);

  function FileNotFoundError(msg, originalError) {
    (0, _classCallCheck3.default)(this, FileNotFoundError);
    return (0, _possibleConstructorReturn3.default)(this, (FileNotFoundError.__proto__ || (0, _getPrototypeOf2.default)(FileNotFoundError)).call(this, msg, originalError, ERROR_NAMES.FileNotFoundError));
  }

  return FileNotFoundError;
}(WrappedError);

var TimedOutError = function (_WrappedError3) {
  (0, _inherits3.default)(TimedOutError, _WrappedError3);

  function TimedOutError(msg, originalError) {
    (0, _classCallCheck3.default)(this, TimedOutError);
    return (0, _possibleConstructorReturn3.default)(this, (TimedOutError.__proto__ || (0, _getPrototypeOf2.default)(TimedOutError)).call(this, msg, originalError, ERROR_NAMES.TimedOutError));
  }

  return TimedOutError;
}(WrappedError);

var OutOfRangeError = function (_WrappedError4) {
  (0, _inherits3.default)(OutOfRangeError, _WrappedError4);

  function OutOfRangeError(msg, originalError) {
    (0, _classCallCheck3.default)(this, OutOfRangeError);
    return (0, _possibleConstructorReturn3.default)(this, (OutOfRangeError.__proto__ || (0, _getPrototypeOf2.default)(OutOfRangeError)).call(this, msg, originalError, ERROR_NAMES.OutOfRangeError));
  }

  return OutOfRangeError;
}(WrappedError);

var ReadFileError = function (_WrappedError5) {
  (0, _inherits3.default)(ReadFileError, _WrappedError5);

  function ReadFileError(msg, originalError) {
    (0, _classCallCheck3.default)(this, ReadFileError);
    return (0, _possibleConstructorReturn3.default)(this, (ReadFileError.__proto__ || (0, _getPrototypeOf2.default)(ReadFileError)).call(this, msg, originalError, ERROR_NAMES.ReadFileError));
  }

  return ReadFileError;
}(WrappedError);

var DataViewError = exports.DataViewError = function (_WrappedError6) {
  (0, _inherits3.default)(DataViewError, _WrappedError6);

  function DataViewError(msg, originalError) {
    (0, _classCallCheck3.default)(this, DataViewError);
    return (0, _possibleConstructorReturn3.default)(this, (DataViewError.__proto__ || (0, _getPrototypeOf2.default)(DataViewError)).call(this, msg, originalError, ERROR_NAMES.DataViewError));
  }

  return DataViewError;
}(WrappedError);

var BufferRangeError = exports.BufferRangeError = function (_WrappedError7) {
  (0, _inherits3.default)(BufferRangeError, _WrappedError7);

  function BufferRangeError(msg, originalError) {
    (0, _classCallCheck3.default)(this, BufferRangeError);
    return (0, _possibleConstructorReturn3.default)(this, (BufferRangeError.__proto__ || (0, _getPrototypeOf2.default)(BufferRangeError)).call(this, msg, originalError, ERROR_NAMES.BufferRangeError));
  }

  return BufferRangeError;
}(WrappedError);

var MagicNumberError = exports.MagicNumberError = function (_Error2) {
  (0, _inherits3.default)(MagicNumberError, _Error2);

  function MagicNumberError(msg) {
    (0, _classCallCheck3.default)(this, MagicNumberError);

    var _this9 = (0, _possibleConstructorReturn3.default)(this, (MagicNumberError.__proto__ || (0, _getPrototypeOf2.default)(MagicNumberError)).call(this, msg));

    _this9.name = ERROR_NAMES.MagicNumberError;
    return _this9;
  }

  return MagicNumberError;
}(Error);

var LoadCommandError = exports.LoadCommandError = function (_Error3) {
  (0, _inherits3.default)(LoadCommandError, _Error3);

  function LoadCommandError(msg) {
    (0, _classCallCheck3.default)(this, LoadCommandError);

    var _this10 = (0, _possibleConstructorReturn3.default)(this, (LoadCommandError.__proto__ || (0, _getPrototypeOf2.default)(LoadCommandError)).call(this, msg));

    _this10.name = ERROR_NAMES.LoadCommandError;
    return _this10;
  }

  return LoadCommandError;
}(Error);

var MissingUUIDError = exports.MissingUUIDError = function (_Error4) {
  (0, _inherits3.default)(MissingUUIDError, _Error4);

  function MissingUUIDError(msg) {
    (0, _classCallCheck3.default)(this, MissingUUIDError);

    var _this11 = (0, _possibleConstructorReturn3.default)(this, (MissingUUIDError.__proto__ || (0, _getPrototypeOf2.default)(MissingUUIDError)).call(this, msg));

    _this11.name = ERROR_NAMES.MissingUUIDError;
    return _this11;
  }

  return MissingUUIDError;
}(Error);

function handleFileError(errMessage, err) {
  if (err instanceof RangeError) {
    throw new OutOfRangeError(errMessage, err);
  }
  switch (err.code) {
    case ERROR_CODES.EACCES:
      throw new AccessError(errMessage, err);
    case ERROR_CODES.ENOENT:
      throw new FileNotFoundError(errMessage, err);
    case ERROR_CODES.ETIMEDOUT:
      throw new TimedOutError(errMessage, err);
    default:
      throw new ReadFileError(errMessage, err);
  }
}