'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.gatherFiles = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var gatherFiles = exports.gatherFiles = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(paths) {
    var _this = this;

    var _ref2 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
        _ref2$globString = _ref2.globString,
        globString = _ref2$globString === undefined ? '**/*.{js,jsx,map,bundle}' : _ref2$globString;

    var map;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            map = [];
            _context2.next = 3;
            return _promise2.default.all(paths.map(function (path) {
              var realPath = (0, _path.join)((0, _process.cwd)(), path);
              var isFile = void 0;

              try {
                isFile = (0, _fs.statSync)(realPath).isFile();
              } catch (err) {
                (0, _errorTypes.handleFileError)('Error accessing stats for ' + path, err);
              }

              if (isFile) {
                map.push({
                  path: realPath,
                  name: (0, _path.basename)(realPath)
                });
              } else {
                try {
                  (0, _glob2.default)(globString, { cwd: realPath, sync: true }).forEach(function () {
                    var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(file) {
                      return _regenerator2.default.wrap(function _callee$(_context) {
                        while (1) {
                          switch (_context.prev = _context.next) {
                            case 0:
                              map.push({
                                path: (0, _path.join)(realPath, file),
                                name: file
                              });

                            case 1:
                            case 'end':
                              return _context.stop();
                          }
                        }
                      }, _callee, _this);
                    }));

                    return function (_x3) {
                      return _ref3.apply(this, arguments);
                    };
                  }());
                } catch (err) {
                  (0, _errorTypes.handleFileError)('Error scanning ' + path + ' for files', err);
                }
              }

              return _promise2.default.resolve();
            }));

          case 3:
            return _context2.abrupt('return', map);

          case 4:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function gatherFiles(_x) {
    return _ref.apply(this, arguments);
  };
}();

var _path = require('path');

var _process = require('process');

var _glob = require('glob');

var _glob2 = _interopRequireDefault(_glob);

var _fs = require('fs');

var _errorTypes = require('./errorTypes');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }